# HG changeset patch
# User Valentin Bartenev <vbart@nginx.com>
# Date 1363008869 -14400
# Node ID 2dc69d57348d83e69e5af3b522dca4e5f5c79b09
# Parent  01c8251670d857920fbc25533f2670fd19bec1e3
Respect the new behavior of TCP_DEFER_ACCEPT.

In Linux 2.6.32, TCP_DEFER_ACCEPT was changed to accept connections
after the deferring period is finished without any data available.
(Reading from the socket returns EAGAIN in this case.)

Since in nginx TCP_DEFER_ACCEPT is set to "post_accept_timeout", we
do not need to wait longer if deferred accept returns with no data.

diff -r 01c8251670d8 -r 2dc69d57348d src/http/ngx_http_request.c
--- a/src/http/ngx_http_request.c	Mon Mar 11 17:34:29 2013 +0400
+++ b/src/http/ngx_http_request.c	Mon Mar 11 17:34:29 2013 +0400
@@ -416,6 +416,20 @@ ngx_http_wait_request_handler(ngx_event_
 
     if (n == NGX_AGAIN) {
 
+#if (NGX_HAVE_DEFERRED_ACCEPT && defined TCP_DEFER_ACCEPT)
+        if (c->listening->deferred_accept
+#if (NGX_HTTP_SSL)
+            && c->ssl == NULL
+#endif
+            )
+        {
+            ngx_log_error(NGX_LOG_INFO, c->log, NGX_ETIMEDOUT,
+                          "client timed out in deferred accept");
+            ngx_http_close_connection(c);
+            return;
+        }
+#endif
+
         if (!rev->timer_set) {
             ngx_add_timer(rev, c->listening->post_accept_timeout);
         }
@@ -617,6 +631,15 @@ ngx_http_ssl_handshake(ngx_event_t *rev)
     if (n == -1) {
         if (err == NGX_EAGAIN) {
 
+#if (NGX_HAVE_DEFERRED_ACCEPT && defined TCP_DEFER_ACCEPT)
+            if (c->listening->deferred_accept) {
+                ngx_log_error(NGX_LOG_INFO, c->log, NGX_ETIMEDOUT,
+                              "client timed out in deferred accept");
+                ngx_http_close_connection(c);
+                return;
+            }
+#endif
+
             if (!rev->timer_set) {
                 ngx_add_timer(rev, c->listening->post_accept_timeout);
             }
